﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Management;
using System.IO.Ports;
using System.Text.RegularExpressions;

namespace TEXIO_Serial_Test
{
    public partial class Form1 : Form
    {
        public int Opened;

        // Open Window
        public Form1()
        {
            InitializeComponent();
            Opened = 0;
            refresh_com();
            cmbBaud.Items.Add("9600");
            cmbBaud.Items.Add("19200");
            cmbBaud.Items.Add("38400");
            cmbBaud.Items.Add("57600");
            cmbBaud.Items.Add("115200");
            cmbBaud.SelectedIndex = 0;

            // Set form
            btnOpen_Close.Text = "OPEN";
            txtSendMsg.Text = "*idn?";
            btnRefesh.Enabled = true;

        }

        // Open/Close Button
        private void btnOpen_Close_Click(object sender, EventArgs e)
        {
            if (btnOpen_Close.Text == "OPEN")
            {
                //Port number assgin
                var matche = new Regex(@"\((.+?)\)").Matches(cmbAddress.Text);
                string portAddress = matche[0].Value.Trim('(', ')');

                try
                {
                    Opened = 1;
                    Cursor.Current = Cursors.WaitCursor;
                    // Device Open and Init
                    serialPort1.PortName = portAddress;
                    serialPort1.BaudRate = Int32.Parse(cmbBaud.Text) ;
                    serialPort1.DataBits = 8;
                    serialPort1.StopBits = System.IO.Ports.StopBits.One;
                    serialPort1.Parity = System.IO.Ports.Parity.None;
                    serialPort1.Handshake = System.IO.Ports.Handshake.None;
                    serialPort1.Open();
                    serialPort1.DiscardInBuffer();

                    serialPort1.WriteLine("*cls");
                    txtSendMsg.Text = "*idn?";

                    // Set form
                    btnOpen_Close.Text = "CLOSE";
                    btnSend.Enabled = true;
                    btnRead.Enabled = true;
                    cmbAddress.Enabled = false;
                    cmbBaud.Enabled = false;
                    btnRefesh.Enabled = false;

                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
                finally
                {
                    Cursor.Current = Cursors.Default;
                }
            }
            else
            {
                try
                {
                    // Device Close
                    serialPort1.WriteLine("*cls");
                    System.Threading.Thread.Sleep(200);
                    serialPort1.Close();

                    // Set form
                    btnOpen_Close.Text = "OPEN";
                    txtReadMsg.Text = "";
                    btnSend.Enabled = false;
                    btnRead.Enabled = false;
                    cmbAddress.Enabled = true;
                    btnRefesh.Enabled = true;
                    cmbBaud.Enabled = true;
                    Opened = 0;
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
        }
        
        // Send Button
        private void btnSend_Click(object sender, EventArgs e)
        {
            string SendMsg = "";

            SendMsg = txtSendMsg.Text;
            try
            {
                txtReadMsg.Text = "";
                serialPort1.WriteLine(SendMsg);

                if (SendMsg.IndexOf("?") >= 0)
                {
                    System.Threading.Thread.Sleep(200);
                    btn_Read();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        // Read Button
        private void btnRead_Click(object sender, EventArgs e)
        {
            btn_Read();
        }

        // Form Close(x Button)
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (Opened == 1)
            {
                try
                {   // Device Close
                    serialPort1.WriteLine("*cls");
                    System.Threading.Thread.Sleep(200);
                    serialPort1.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
        }

        private void btnRefesh_Click(object sender, EventArgs e)
        {
            refresh_com();
        }


        // Rescan comport
        private void refresh_com()
        {
            cmbAddress.Items.Clear();
            cmbAddress.Text = "";

            // Port number only
            //string[] PortList = SerialPort.GetPortNames();
            //foreach (string PortName in PortList) cmbAddress.Items.Add("("+PortName+")");

            //Port description  FTDI:OK 
            var CheckComNum = new System.Text.RegularExpressions.Regex("COM[1-9][0-9]?[0-9]?");
            System.Management.ManagementClass mcPnPEntity = new System.Management.ManagementClass("Win32_PnPEntity");
            System.Management.ManagementObjectCollection manageObjCol = mcPnPEntity.GetInstances();
            foreach (System.Management.ManagementObject manageObj in manageObjCol)
            {
                var namePropertyValue = manageObj.GetPropertyValue("Name");
                if (namePropertyValue == null) continue;

                string name = namePropertyValue.ToString();
                if (CheckComNum.IsMatch(name))  cmbAddress.Items.Add(name);
            }
            if (cmbAddress.Items.Count > 0) cmbAddress.SelectedIndex = 0;
        }

        private void btn_Read()
        {
            try
            {
                Cursor.Current = Cursors.WaitCursor;
                txtReadMsg.Text = serialPort1.ReadExisting() + "\r\n";
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                Cursor.Current = Cursors.Default;
            }
        }
    }
}
